#!/bin/sh
#
#
# firewall service


iptables=/sbin/iptables

reset() {
 iptables -D OUTPUT -t nat -m owner --uid-owner nobody -j ACCEPT 2>/dev/null
 iptables -D OUTPUT -t nat -m owner --uid-owner dansguardian -j ACCEPT 2>/dev/null
 iptables -D OUTPUT -t nat -p tcp --dport 80 -j DNAT --to-destination 127.0.0.1:8080 2> /dev/null
 iptables -D OUTPUT -t nat -p tcp --dport 80 -j DNAT --to-destination 127.0.0.1:3128 2> /dev/null
 iptables -D OUTPUT -t nat -p tcp --dport 8080 -j DNAT \
 	--to-destination 127.0.0.1:8080 2> /dev/null
 iptables -D OUTPUT -t nat -p tcp --dport 3128 -j DNAT \
 	--to-destination 127.0.0.1:8080 2> /dev/null
 iptables -D OUTPUT -t nat -p tcp --dport 8080 -j DNAT \
 	--to-destination 127.0.0.1:3128 2> /dev/null
 iptables -D OUTPUT -t nat -p tcp --dport 3128 -j DNAT \
 	--to-destination 127.0.0.1:3128 2> /dev/null

}


filter() {
 iptables -I OUTPUT -t nat -m owner --uid-owner nobody -j ACCEPT
 iptables -I OUTPUT -t nat -m owner --uid-owner dansguardian -j ACCEPT
 iptables -A OUTPUT -t nat -p tcp --dport 80 -j DNAT --to-destination 127.0.0.1:8080
 iptables -A OUTPUT -t nat -p tcp --dport 8080 -j DNAT --to-destination 127.0.0.1:8080
 iptables -A OUTPUT -t nat -p tcp --dport 3128 -j DNAT --to-destination 127.0.0.1:8080
}


proxy() {
 iptables -I OUTPUT -t nat -m owner --uid-owner nobody -j ACCEPT
 iptables -I OUTPUT -t nat -m owner --uid-owner dansguardian -j ACCEPT
 iptables -A OUTPUT -t nat -p tcp --dport 80 -j DNAT --to-destination 127.0.0.1:3128
 iptables -A OUTPUT -t nat -p tcp --dport 8080 -j DNAT --to-destination 127.0.0.1:3128
 iptables -A OUTPUT -t nat -p tcp --dport 3128 -j DNAT --to-destination 127.0.0.1:3128
}

case "$1" in

	filter)
		reset
		filter
	;;

	proxy)
		reset
		proxy
	;;

	stop)
		reset
	;;

	*)
	echo "$0 [filter/proxy/stop]"
	;; 
esac

